<template>
  <div id="app" class="container">
    <StartScreen v-if='startScreen' @start-event="start"/>
    <h2 id="loading-message" v-if="!(startScreen || questionScreen || resultsScreen)">Loading questions...</h2>
    <QuestionScreen 
      v-if='questionScreen'
      :questions="this.questions"
      :score="this.score"
      @answer-event='answer'
      />
    <ResultsScreen 
      v-if='resultsScreen' 
      :questions="this.questions"
      :score="this.score"
    />
  </div>
</template>

<script>
import StartScreen from './components/StartScreen';
import QuestionScreen from './components/QuestionScreen';
import ResultsScreen from './components/ResultsScreen';
import {getQuestions} from './api/opentdb';
export default {
  name: 'App',
  components: {
    StartScreen,
    QuestionScreen,
    ResultsScreen
  },
  data() {
    return {
      startScreen: true,
      questionScreen: false,
      resultsScreen: false,
      score: 0,
      questions: [],
      currentQuestion: 0
    };
  },
  methods: {
    async start() {
      this.startScreen = false;
      this.questions = await getQuestions();
      this.questionScreen = true;
    },
    answer(text) {
      this.questions[this.currentQuestion].user_answer = text;
      if (this.questions[this.currentQuestion++].correct_answer == text) {
        this.score += 10;
      }
      if (this.currentQuestion >= this.questions.length) {
        this.questionScreen = false;
        this.resultsScreen = true;
      }
    }
  }
}
</script>

<style>
@import './app.css';
</style>
